
// Подключаем библиотеку Servo.h
// для работы с серводвигателями
#include <Servo.h>

// Создаём объект класса Servo
// из библиотеки Servo.h
Servo myservo;

// Вспомогательная переменная с
// текущим углом
int pos = 0;

void setup()
{
    // Обозначаем, что серводвигатель
    // подсоединён к 9-му пину
    myservo.attach(9); 
}


void loop()
{
    // Пробегаем все значения от 0 до 180 градусов
    // по одному градусу на каждом шаге
    for(pos = 0; pos < 180; pos += 1) { 
        // Даём команду серво повернуться на
        // заданный угол
        myservo.write(pos); 

        // Ждём 15 мс, пока серво повернётся на 1°.
        // Время поворота зависит от модели сервы,
        // 15 мс — просто подобранная величина
        delay(15); 
    }

    // Делаем то же, что и в предыдущем цикле,
    // но в обратном порядке
    for(pos = 180; pos>=1; pos-=1) {
        myservo.write(pos);
        delay(15);
    }
}
